//LabPlot : ListDialog.h

#ifndef LISTDIALOG_H
#define LISTDIALOG_H

#include <qtextstream.h>
#include "GraphListView.h"
#include "Dialog.h"

/*! main dialog for all list dialogs */
class ListDialog : public Dialog
{
	Q_OBJECT
public:
	ListDialog(Worksheet *p, Spreadsheet *s, const char *name);
	void updateList();
public slots:
	void Menu(QListViewItem *item, const QPoint& pos , int) {menu->popup(pos); }
	void updateRange();
	void toggleShown();
	void deleteGraph();
	void changeGraph();
	void dumpGraph();
	void editGraph();
	void openSpreadsheet();
	void statGraph();
protected:
	Worksheet *p;
	Spreadsheet *s;
	class GraphListView *lv;
	QPopupMenu *menu;
	PType type;
	KLineEdit *ale, *ble;
};

#endif // LISTDIALOG_H
